<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Запрос SQL в базу данных</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/mini.css/3.0.1/mini-default.min.css">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="common.js"></script>
</head>
<body>
<style>
    textarea {
        width: 100%;
    }
</style>
<form name="sql" onsubmit="doQuery();return false">
    <h1>Запрос SQL в базу данных</h1>
    <fieldset>
        <textarea name="query">SELECT id, username, password, balance FROM users</textarea>
    </fieldset>
    <button type="submit">Выполнить</button>
</form>
<div id="output"></div>
<script>
    function doQuery() {
        var queryInput = document.querySelector('form[name=sql] textarea[name=query]');

        var data = {
            query: queryInput.value
        };

        var request = new XMLHttpRequest();
        request.open('POST', '/api/db/select', true);
        processRequest(request, function (data) {
            var output = document.getElementById('output')
            while (output.firstChild) {
                output.removeChild(output.lastChild);
            }

            var results = data.results;
            if (results.length > 0) {
                var table = document.createElement('table');
                var first = results[0];
                var keys = Object.keys(first);
                var tr = document.createElement('tr');
                for (var key of keys) {
                    var td = document.createElement('th');
                    td.innerHTML = key;
                    tr.appendChild(td);
                }
                table.appendChild(tr);

                for (var obj of data.results) {
                    var tr = document.createElement('tr');
                    var values = Object.values(obj);
                    for (var value of values) {
                        var td = document.createElement('td');
                        td.innerHTML = value === null ? 'null' : value;
                        tr.appendChild(td);
                    }
                    table.appendChild(tr);
                }
                output.appendChild(table);
            }
        });
        request.send(JSON.stringify(data));
    }
</script>
</body>
</html>
